# Testing Basic functionality
Feature: Basic functionality

  Background: Open main list form
    Given I open the main page with username "admin" and password "admin"

  Scenario: 001 - Test simple dictionary (simpleDictA)
    And I open list form of entity with type "DICTIONARY" and name "Simple Dict A"
    And number of rows in table of entity list with type "DICTIONARY" and name "Simple Dict A" must be 0
    And I open form for new entity with type "DICTIONARY" and name "Simple Dict A"
    And field "Key" must be ""
    And field "Name" must be ""
    And provide value "Name Original" to field "Name"
    And click button with text "Save"
    And field "Key" must be "0000000001"
    And I open list form of entity with type "DICTIONARY" and name "Simple Dict A"
    And number of rows in table of entity list with type "DICTIONARY" and name "Simple Dict A" must be 1
    And I choose row in table of entity list with type "DICTIONARY" and name "Simple Dict A" where value in column "Key" is "0000000001"
    And value in current row in column "Name" must be "Name Original"
    And I open form for entity with type "DICTIONARY", name "Simple Dict A", and key "0000000001"
    And field "Key" must be "0000000001"
    And field "Name" must be "Name Original"
    And provide value "Name New" to field "Name"
    And click button with text "Save"
    And I open list form of entity with type "DICTIONARY" and name "Simple Dict A"
    And I choose row in table of entity list with type "DICTIONARY" and name "Simple Dict A" where value in column "Key" is "0000000001"
    And value in current row in column "Name" must be "Name New"
    And I close all open tabs
  Scenario: 002 - Test complex dictionary (complexDictB)
    And I open form for new entity with type "DICTIONARY" and name "Complex Dict (B)"
    And provide value "Name Original" to field "Name"
    And provide value "123.45" to field "Num Field"
    And provide value "Original string" to field "Str Field"
    And provide value "345" to field "Int Field"
    And provide value "2021-12-01 22:25:15" to field "Date Field"
    And provide value "Enum (Two)" to field "Enum Field"
    And provide value "Name New" to field "SimpleDict Field"
    And provide value "CHECKED" to checkbox "Bool Field"
    And click button with text "Save"
    And I open list form of entity with type "DICTIONARY" and name "Complex Dict (B)"
    And number of rows in table of entity list with type "DICTIONARY" and name "Complex Dict (B)" must be 1
    And I choose row in table of entity list with type "DICTIONARY" and name "Complex Dict (B)" where value in column "Key" is "DB-0000001"
    And value in current row in column "Name" must be "Name Original"
    And value in current row in column "Num Field" must be "123.45"
    And value in current row in column "Str Field" must be "Original string"
    And value in current row in column "Int Field" must be "345"
    And value in current row in column "Date Field" must be "Dec 1, 2021, 10:25:15 PM"
    And value in current row in column "Enum Field" must be "Enum (Two)"
    And value in current row in column "SimpleDict Field" must be "Name New"
    And checkbox in current row in column "Bool Field" must be "CHECKED"
    And I open form for entity with type "DICTIONARY", name "Complex Dict (B)", and key "DB-0000001"
    And provide value "Name New" to field "Name"
    And provide value "234.56" to field "Num Field"
    And provide value "New string" to field "Str Field"
    And provide value "456" to field "Int Field"
    And provide value "2021-12-02 22:25:15" to field "Date Field"
    And provide value "Enum (One)" to field "Enum Field"
    And provide value "Name New" to field "SimpleDict Field"
    And provide value "UNCHECKED" to checkbox "Bool Field"
    And click button with text "Save"
    And I open list form of entity with type "DICTIONARY" and name "Complex Dict (B)"
    And number of rows in table of entity list with type "DICTIONARY" and name "Complex Dict (B)" must be 1
    And I choose row in table of entity list with type "DICTIONARY" and name "Complex Dict (B)" where value in column "Key" is "DB-0000001"
    And value in current row in column "Name" must be "Name New"
    And value in current row in column "Num Field" must be "234.56"
    And value in current row in column "Str Field" must be "New string"
    And value in current row in column "Int Field" must be "456"
    And value in current row in column "Date Field" must be "Dec 2, 2021, 10:25:15 PM"
    And value in current row in column "Enum Field" must be "Enum (One)"
    And value in current row in column "SimpleDict Field" must be "Name New"
    And checkbox in current row in column "Bool Field" must be "UNCHECKED"
    And I close all open tabs
